<?php
/**
 * Created by PhpStorm.
 * User: dido
 * Date: 4/20/16
 * Time: 9:55 PM
 */

namespace Elbotrade\Bundle\GalleryBundle\Controller;

use Elbotrade\Bundle\GalleryBundle\Controller\GalleryController;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Component\HttpFoundation\Request;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Template;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Route;

class GalleryBackendController extends GalleryController
{

    /**
     * @Route("/elbotrade/gallery/backend/list", name="elbotrade_gallery_backend_list")
     * @Template()
     */
    public function listAction()
    {

        return parent::listAction(); // TODO: Change the autogenerated stub
    }

    /**
     * @Route("/elbotrade/gallery/backend/show/{galleryId}", name="elbotrade_gallery_backend_show")
     * @Template()
     */
    public function showAction($galleryId)
    {

        return parent::showAction($galleryId); // TODO: Change the autogenerated stub
    }

    /**
     * @param Request $request
     * @return array
     * @throws \Exception
     * @Route("/elbotrade/gallery/backend/create", name="elbotrade_gallery_backend_create")
     * @Template();
     */
    public function createAction(Request $request)
    {

        $galleryManager = $this->get('elbotrade.gallery_bundle.gallery_manager');

        $gallery = $galleryManager->createGallery();
        $gallery->setContext('default');
        $gallery->setEnabled(true);

        $form = $this->createForm(
            $this->get('elbotrade.gallery_bundle.gallery_type'), $gallery, ['action' => $this->generateUrl('elbotrade_gallery_backend_create')]
        );

        if ($request->isMethod(Request::METHOD_POST)) {
            if ($gallery = $galleryManager->handleGalleryForm($form, $gallery, $request)) {
                $galleryManager->saveGallery($gallery);
                return $this->redirect($this->generateUrl('elbotrade_gallery_backend_list'));
            } else {
                throw new \Exception('Could not save gallery');
            }
        }

        $form->setData($gallery);

        return [
            'form' => $form->createView()
        ];
    }

    /**
     * @Route("/elbotrade/gallery/backend/update/{galleryId}", name="elbotrade_gallery_backend_update")
     * @Template()
     */
    public function updateAction(Request $request, $galleryId)
    {

        $galleryManager = $this->get('elbotrade.gallery_bundle.gallery_manager');
        $galleryFinder = $this->get('elbotrade.gallery_bundle.media_finder');

        $gallery = $galleryFinder->findGallery($galleryId);

        $form = $this->createForm(
            $this->get('elbotrade.gallery_bundle.gallery_type'), $gallery, ['action' => $this->generateUrl('elbotrade_gallery_backend_update', ['galleryId' => $galleryId])]
        );

        if ($request->isMethod(Request::METHOD_POST)) {
            if ($gallery = $galleryManager->handleGalleryForm($form, $gallery, $request)) {
                $galleryManager->saveGallery($gallery);
                return $this->redirect($this->generateUrl('elbotrade_gallery_backend_list'));
            } else {
                throw new \Exception('Could not save gallery');
            }
        }

        $form->setData($gallery);

        return [
            'form' => $form->createView(),
            'galleryHasMedias' => $gallery->getGalleryHasMedias()
        ];
    }

    /**
     * @Route("/elbotrade/gallery/backend/delete/{galleryId}", name="elbotrade_gallery_backend_delete")
     */
    public function deleteAction($galleryId)
    {

        $galleryManager = $this->get('elbotrade.gallery_bundle.gallery_manager');
        $galleryFinder = $this->get('elbotrade.gallery_bundle.media_finder');

        $gallery = $galleryFinder->findGallery($galleryId);

        $galleryManager->removeGallery($gallery);

        return $this->redirect($this->generateUrl('elbotrade_gallery_backend_list'));
    }

    /**
     * @param $mediaId
     * @param $galleryHasMediaId
     * @Route("/elbotrade/gallery/backend/remove_media_from_gallery/{mediaId}/{galleryHasMediaId}", name="elbotrade_gallery_backend_remove_media_from_gallery")
     * @return array
     */
    public function removeMediaFromGallery($mediaId, $galleryHasMediaId)
    {

        $galleryManager = $this->get('elbotrade.gallery_bundle.gallery_manager');
        $mediaManager = $this->get('sonata.media.manager.media');
        $galleryFinder = $this->get('elbotrade.gallery_bundle.media_finder');

        $media = $mediaManager->find($mediaId);
        $galleryHasMedia = $galleryFinder->findGalleryHasMedia($galleryHasMediaId);

        $galleryManager->removeGalleryHasMedia($galleryHasMedia);
        $galleryManager->removeMedia($media);

        $this->getDoctrine()->getManager()->flush();

        return new JsonResponse(['code' => '200', 'response' => 'ok']);
    }
}